%flash no flash
clc
close all
clear all
epsilon=0.02;
A=imread('potsdetail_01_noflash.tif');
F= imread('potsdetail_00_flash.tif');
 
sigmaC=1;sigmaD=7;
 r=24;
 A_base=bilateral(A,r,sigmaC,sigmaD);
 A_NR=bilateral(A,r,sigmaC,sigmaD,F);
 F_base=bilateral(F,r,sigmaC,sigmaD);
%  save('images3.mat');
 
%% 
load('images1.mat');
 F_detail= (double(F) +epsilon)./(F_base+epsilon);
figure(1);
imshow(uint8(A))
figure
imshow(uint8(F))
figure


prompt = 'Input Tau shadow? Enter q with single quotes to exit';
while(1) 
    key = input(prompt);
    if(key=='q')
        break;
    end

    Mshadow= (F-A)<key;
    imshow(uint8(255*double(Mshadow)));
    
end
Mspec=F> 0.95*max(F(:));
n=5;
M=clean(Mshadow,n)| clean(Mspec,n);

gaussian = fspecial('gaussian',n,3);
gaussian = gaussian ./ max(gaussian(:));

M=imfilter(M,gaussian,'same');


A_final=(1-M).*A_NR.*F_detail+M.*A_base;
figure
imshow(uint8(A_final));
imwrite(uint8(A_NR),'bilateral1.tif');
imwrite(uint8(A_final),'final1.tif');
 
%white balance doesnt work
% [ Awb ] = wbColor( A,F,A_final,0.02 );

