
function newIm=bilateral(image,r,sigmaC,sigmaD,varargin)
%bilateral filter , or joint filter if given a 2nd image

 
 if (isempty(varargin))
crossImage= double((image));
 else
    crossImage=double(varargin{1}); 
 end
image = padarray(image,[r r],'symmetric','both' );
crossImage = padarray(crossImage,[r r],'symmetric','both' );
[h w n]=size(image);
  image=double(image);
gaussian = fspecial('gaussian',2*r+1,sigmaD);
gaussian = gaussian ./ max(gaussian(:));


newIm=zeros(size(image));
  
for k=1:n
  
for i=r+1:1:h-r
    for j=r+1:1:w-r
   diffWindc=crossImage(i-r:i+r,j-r:j+r,k)-crossImage(i,j,k);
     window  =exp((-1/2*sigmaC*sigmaC)*(diffWindc.*diffWindc ));
     
     bfWindow=gaussian.*window;
    val= bfWindow.* image(i-r:i+r,j-r:j+r,k);
     newIm(i,j,k)= sum(val(:))/sum(bfWindow(:));
       
            
    end
end
end
  newIm=newIm(r+1:h-r,r+1:w-r,:);
end
 